viSetGetForMoh = {};
viSetGetForMoh.cmd = {};

function viSetGetForMoh:loadPdaIcons()
	g_currentMission.multiOverlayV4.overlayFunction.savePreviewIcons( {xmlTagName="viIcons.vehiclePda", modDir=VehicleInspector.modDir, iconFile="scripte/mohFeatures/vehicles1.dds", xmlFile="scripte/mohFeatures/viIcons.xml", modName="VehicleInspector", groupName="vehicle", fileFormat="m512x512", previewIcons=true} );
end;

function viSetGetForMoh:loadCmds()
	g_currentMission.multiOverlayV4.cmdFunction.generateCmd( { 
			modName = "VehicleInspector";
			cmdName = "action_viJoinAllVehicle_";
			groupName = "VehicleInspector-Join";			
			displayName = "Join forward/back Vehicle(all)";
			infoTxt = "Click Left Join Forward/Click Right Join Back";
			mouseClickAccepts = {true,false,true};
			ownTable = {joinType="all"};
			typ = {"action_"};			
			actionCallback = viSetGetForMoh.cmd.joinVehicle;		
		}
	);
	g_currentMission.multiOverlayV4.cmdFunction.generateCmd( { 
			modName = "VehicleInspector";
			cmdName = "action_viJoinTractorVehicle_";
			groupName = "VehicleInspector-Join";			
			displayName = "Join forward/back Vehicle(tractor)";
			infoTxt = "";
			mouseClickAccepts = {true,false,true};
			ownTable = {joinType="tractor"};
			typ = {"action_"};			
			actionCallback = viSetGetForMoh.cmd.joinVehicle;		
		}
	);
	g_currentMission.multiOverlayV4.cmdFunction.generateCmd( { 
			modName = "VehicleInspector";
			cmdName = "action_viJoinHarvesterVehicle_";
			groupName = "VehicleInspector-Join";			
			displayName = "Join forward/back Vehicle(harvester)";
			infoTxt = "";
			mouseClickAccepts = {true,false,true};
			ownTable = {joinType="harvester"};
			typ = {"action_"};			
			actionCallback = viSetGetForMoh.cmd.joinVehicle;		
		}
	);
	g_currentMission.multiOverlayV4.cmdFunction.generateCmd( { 
			modName = "VehicleInspector";
			cmdName = "action_viJoinTruckVehicle_";
			groupName = "VehicleInspector-Join";			
			displayName = "Join forward/back Vehicle(truck)";
			infoTxt = "";
			mouseClickAccepts = {true,false,true};
			ownTable = {joinType="truck"};
			typ = {"action_"};			
			actionCallback = viSetGetForMoh.cmd.joinVehicle;		
		}
	);
	g_currentMission.multiOverlayV4.cmdFunction.generateCmd( { 
			modName = "VehicleInspector";
			cmdName = "action_viJoinTeleLoaderVehicle_";
			groupName = "VehicleInspector-Join";			
			displayName = "Join forward/back Vehicle(teleloader)";
			infoTxt = "";
			mouseClickAccepts = {true,false,true};
			ownTable = {joinType="teleloader"};
			typ = {"action_"};			
			actionCallback = viSetGetForMoh.cmd.joinVehicle;		
		}
	);
	g_currentMission.multiOverlayV4.cmdFunction.generateCmd( { 
			modName = "VehicleInspector";
			cmdName = "action_viJoinCarVehicle_";
			groupName = "VehicleInspector-Join";			
			displayName = "Join forward/back Vehicle(car)";
			infoTxt = "";
			mouseClickAccepts = {true,false,true};
			ownTable = {joinType="car"};
			typ = {"action_"};			
			actionCallback = viSetGetForMoh.cmd.joinVehicle;		
		}
	);
	g_currentMission.multiOverlayV4.cmdFunction.generateCmd( { 
			modName = "VehicleInspector";
			cmdName = "action_viJoinOtherVehicle_";
			groupName = "VehicleInspector-Join";			
			displayName = "Join forward/back Vehicle(other)";
			infoTxt = "";
			mouseClickAccepts = {true,false,true};
			ownTable = {joinType="other"};
			typ = {"action_"};			
			actionCallback = viSetGetForMoh.cmd.joinVehicle;		
		}
	);
	g_currentMission.multiOverlayV4.cmdFunction.generateCmd( { 
			modName = "VehicleInspector";
			cmdName = "action_viJoinTractorWithAttachedVehicle_";
			groupName = "VehicleInspector-Join";			
			displayName = "Join forward/back Vehicle with Attached(tractor)";
			infoTxt = "";
			mouseClickAccepts = {true,false,true};
			ownTable = {joinType="tractor", attachedType="all"};
			typ = {"action_"};			
			actionCallback = viSetGetForMoh.cmd.joinVehicle;		
		}
	);
	g_currentMission.multiOverlayV4.cmdFunction.generateCmd( { 
			modName = "VehicleInspector";
			cmdName = "action_viJoinTractorWithoutAttachedVehicle_";
			groupName = "VehicleInspector-Join";			
			displayName = "Join forward/back Vehicle without Attached(tractor)";
			infoTxt = "";
			mouseClickAccepts = {true,false,true};
			ownTable = {joinType="tractor", attachedType="none"};
			typ = {"action_"};			
			actionCallback = viSetGetForMoh.cmd.joinVehicle;		
		}
	);
	g_currentMission.multiOverlayV4.cmdFunction.generateCmd( { 
			modName = "VehicleInspector";
			cmdName = "action_viJoinAllParkingVehicle_";
			groupName = "VehicleInspector-Join";			
			displayName = "Join forward/back Vehicle is Parking(all)";
			infoTxt = "needs Parking Mod";
			mouseClickAccepts = {true,false,true};
			ownTable = {joinType="all", attachedType="parking"};
			typ = {"action_"};			
			actionCallback = viSetGetForMoh.cmd.joinVehicle;		
		}
	);
end;

function viSetGetForMoh.cmd.joinVehicle(args)
	if args == nil or type(args) ~= "table" or args.cmdTable == nil or args.cmdTable.ownTable == nil or args.mouseClick == nil then return;end;
	if (args.mouseClick == "MOUSE_BUTTON_LEFT" or args.mouseClick == "MOUSE_BUTTON_RIGHT") and args.isDown then
		local joinType = args.cmdTable.ownTable.joinType;
		local trailer = args.cmdTable.ownTable.attachedType ~= nil;		
		local attachedType = args.cmdTable.ownTable.attachedType
		if args.mouseClick == "MOUSE_BUTTON_LEFT" then 
			viSetGetForMoh:joinVehicle(1, joinType, trailer, attachedType);			
		elseif args.mouseClick == "MOUSE_BUTTON_RIGHT" then 
			viSetGetForMoh:joinVehicle(-1, joinType, trailer, attachedType);
		end;
	end;
	return;
end;

function viSetGetForMoh:isParkingVehicle(vehicle) --parkingMod
	if vehicle.spec_parkvehicle ~= nil then
		local spec = vehicle.spec_parkvehicle;
		if spec.state[spec.uniqueUserId] then return true;end;
		return false;
	end;
	return false;
end;

function viSetGetForMoh:getAttachedType(vehicle, attachedType, attachedNr)	
	local attached = 0;	
	if attachedNr == 0 and vehicle.getAttachedImplements == nil and (attachedType == "none" or attachedType == "all") then return -1;end;
	if vehicle.getAttachedImplements ~= nil then 
		local attachTable = vehicle:getAttachedImplements(vehicle);
		if attachTable ~= nil then		
			for _,attach in pairs(attachTable) do		
				if attach.object ~= nil and attach.object.typeName ~= nil then
					local typeName = Utils.getNoNil(attach.object.typeName, "Unknown"):lower();
					if not string.find(typeName, "implement") then
						attached = attached+1;
						if attachedType == "all" or attachedType == "none" then break;end;											
						if attach.object.viCategoryName ~= nil and attach.object.viCategoryName ~= attachedType then attached = attached-1;end;
					end;					
					local tempAttached = viSetGetForMoh:getAttachedType(attach.object, attachedType, attachedNr+1);
					attached = attached+tempAttached;					
				end;
			end;
		end;
	end;
	return attached;
end;

function viSetGetForMoh:joinVehicle(delta, joinType, trailer, attachedType)
	local isParkingVehicle = false;
	function isVehicleAndTrailerType(vehicle)
		if vehicle.viCategoryName == "nosupport" then return false;end;
		isParkingVehicle = viSetGetForMoh:isParkingVehicle(vehicle)
		if joinType == "all" and trailer and attachedType == "parking" then return isParkingVehicle;end;
		if joinType == "all" then return true;end;
		if joinType == vehicle.viCategoryName then 
			if not trailer then return true;end;
			local attached = viSetGetForMoh:getAttachedType(vehicle, attachedType, 0);
			if attached == -1 then return false;end;
			if attached <= 0 and attachedType == "none" then return true;end;
			if attached > 0 and attachedType == "none" then return false;end;
			return attached > 0;
		end;			
		return false;
	end;	
		
	if not g_currentMission.isToggleVehicleAllowed then
		return;
	end;
	local numVehicles = #g_currentMission.enterables;
	if numVehicles > 0 then
		local index = 1;
		local oldIndex = 1;
		if not g_currentMission.controlPlayer and g_currentMission.controlledVehicle ~= nil then
			for i = 1, numVehicles do
				if g_currentMission.controlledVehicle == g_currentMission.enterables[i] then
					oldIndex = i;
					index = i + delta;
					if numVehicles < index then
						index = 1;
					end;
					if index < 1 then
						index = numVehicles;
					end;
					break;
				end;
			end;
		elseif delta < 0 then
			index = numVehicles;
		end;
		local found = false;
		repeat
			local enterable = g_currentMission.enterables[index];			
			local canTabbable = enterable:getIsTabbable();
			local canJoinType = isVehicleAndTrailerType(enterable);
			if not canTabbable and trailer and attachedType == "parking" and isParkingVehicle then canTabbable = true;end;
			if canJoinType and canTabbable and enterable:getIsEnterable() then
				found = true;
			else
				index = index + delta;
				if numVehicles < index then
					index = 1;
				end;
				if index < 1 then
					index = numVehicles;
				end;
			end;
		until found or index == oldIndex;
		if found then
			g_currentMission:requestToEnterVehicle(g_currentMission.enterables[index]);
		end;
	end;	
end;

function viSetGetForMoh:generateVehicleInspectorPda()
	if not VehicleInspector.global.foundMoh or VehicleInspector.moh == nil then return;end;
	local pda = g_currentMission.multiOverlayV4.pdaFunction.getPdaTable("viVehiclePda_");
	if pda ~= nil then g_currentMission:showBlinkingWarning("VehicleInspector PDA already exists", 3000);return;end;
	local isGenerate = g_currentMission.multiOverlayV4.pdaFunction.generatePda("viVehiclePda_", "VehicleInspector Pda");
	if not isGenerate then g_currentMission:showBlinkingWarning("Generate VehicleInspector PDA Error/nGenerate manual", 3000);return;end;
	
	VehicleInspector.moh.moSetGetPda:generateApp( {whatClick="viVehiclePda_", appValue={1,1}} );
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].apps[1][1].cmd[1] = {regName="VehicleInspector_cmd_action_viJoinAllVehicle_",displayName="Join forward/back Vehicle(all)", mouseClick={true,false,true}};
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].selectApp = {1,1};
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.openMod = "VehicleInspector";
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.openGroup = "vehicle";
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.selectIcon = 1;
	VehicleInspector.moh.moGeneralSettings.appIconSettingMenue.name = "viVehiclePda_";
	local isPreviewIconLoad = false;
	if VehicleInspector.moh.moSetGetOverlays.previewIcons["MultiOverlayV4"] == nil then VehicleInspector.moh.moSetGetOverlays:loadPreviewIcons();isPreviewIconLoad = true;end;
	VehicleInspector.moh.moHlGuiAppIconSetting:addIcon( {editTable=VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"]} );
	
	VehicleInspector.moh.moSetGetPda:generateApp( {whatClick="viVehiclePda_", appValue={1,2}} );
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].apps[1][2].cmd[1] = {regName="VehicleInspector_cmd_action_viJoinTractorVehicle_",displayName="Join forward/back Vehicle(tractor)", mouseClick={true,false,true}};
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].selectApp = {1,2};
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.openMod = "VehicleInspector";
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.openGroup = "vehicle";
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.selectIcon = 2;
	VehicleInspector.moh.moHlGuiAppIconSetting:addIcon( {editTable=VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"]} );
	
	VehicleInspector.moh.moSetGetPda:generateApp( {whatClick="viVehiclePda_", appValue={1,3}} );
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].apps[1][3].cmd[1] = {regName="VehicleInspector_cmd_action_viJoinHarvesterVehicle_",displayName="Join forward/back Vehicle(harvester)", mouseClick={true,false,true}};
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].selectApp = {1,3};
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.openMod = "VehicleInspector";
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.openGroup = "vehicle";
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.selectIcon = 3;
	VehicleInspector.moh.moHlGuiAppIconSetting:addIcon( {editTable=VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"]} );
	
	VehicleInspector.moh.moSetGetPda:generateApp( {whatClick="viVehiclePda_", appValue={1,4}} );
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].apps[1][4].cmd[1] = {regName="VehicleInspector_cmd_action_viJoinTruckVehicle_",displayName="Join forward/back Vehicle(truck)", mouseClick={true,false,true}};
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].selectApp = {1,4};
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.openMod = "VehicleInspector";
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.openGroup = "vehicle";
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.selectIcon = 4;
	VehicleInspector.moh.moHlGuiAppIconSetting:addIcon( {editTable=VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"]} );
	
	VehicleInspector.moh.moSetGetPda:generateApp( {whatClick="viVehiclePda_", appValue={1,5}} );
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].apps[1][5].cmd[1] = {regName="VehicleInspector_cmd_action_viJoinTeleLoaderVehicle_",displayName="Join forward/back Vehicle(teleloader)", mouseClick={true,false,true}};
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].selectApp = {1,5};
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.openMod = "VehicleInspector";
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.openGroup = "vehicle";
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.selectIcon = 5;
	VehicleInspector.moh.moHlGuiAppIconSetting:addIcon( {editTable=VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"]} );
	
	VehicleInspector.moh.moSetGetPda:generateApp( {whatClick="viVehiclePda_", appValue={1,6}} );
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].apps[1][6].cmd[1] = {regName="VehicleInspector_cmd_action_viJoinCarVehicle_",displayName="Join forward/back Vehicle(car)", mouseClick={true,false,true}};
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].selectApp = {1,6};
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.openMod = "VehicleInspector";
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.openGroup = "vehicle";
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.selectIcon = 6;
	VehicleInspector.moh.moHlGuiAppIconSetting:addIcon( {editTable=VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"]} );
	
	VehicleInspector.moh.moSetGetPda:generateApp( {whatClick="viVehiclePda_", appValue={1,7}} );
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].apps[1][7].cmd[1] = {regName="VehicleInspector_cmd_action_viJoinOtherVehicle_",displayName="Join forward/back Vehicle(other)", mouseClick={true,false,true}};
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].selectApp = {1,7};
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.openMod = "VehicleInspector";
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.openGroup = "vehicle";
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.selectIcon = 9;
	VehicleInspector.moh.moHlGuiAppIconSetting:addIcon( {editTable=VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"]} );
	
	VehicleInspector.moh.moSetGetPda:generateApp( {whatClick="viVehiclePda_", appValue={1,8}} );
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].apps[1][8].cmd[1] = {regName="VehicleInspector_cmd_action_viJoinTractorWithAttachedVehicle_",displayName="Join forward/back Vehicle with Attached(tractor)", mouseClick={true,false,true}};
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].selectApp = {1,8};
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.openMod = "VehicleInspector";
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.openGroup = "vehicle";
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.selectIcon = 7;
	VehicleInspector.moh.moHlGuiAppIconSetting:addIcon( {editTable=VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"]} );
	
	VehicleInspector.moh.moSetGetPda:generateApp( {whatClick="viVehiclePda_", appValue={1,9}} );
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].apps[1][9].cmd[1] = {regName="VehicleInspector_cmd_action_viJoinTractorWithoutAttachedVehicle_",displayName="Join forward/back Vehicle without Attached(tractor)", mouseClick={true,false,true}};
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].selectApp = {1,9};
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.openMod = "VehicleInspector";
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.openGroup = "vehicle";
	VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"].appIconSettings.selectIcon = 8;
	VehicleInspector.moh.moHlGuiAppIconSetting:addIcon( {editTable=VehicleInspector.moh.moSetGetOverlays.pda["viVehiclePda_"]} );
	
	if isPreviewIconLoad then VehicleInspector.moh.moSetGetOverlays:deletePreviewIcons();end;
	VehicleInspector.moh.moGeneralSettings.appIconSettingMenue.name = "";
	--VehicleInspector.moh.moHlGuiAppIconSetting:setClose();

end;

